﻿using System;


namespace AssemblyCSharp
{
    public class Tile
    {
        private int X;
        private int Y;
        public Unit Unit;
        public Terrain Terrain;

        public Tile() { }

        public Tile(int x, int y, Terrain t)
        {
            this.X = x;
            this.Y = y;
            Terrain = t;
            Unit = null;
        }

        public String toDebug()
        {
            return "Tile " + X + "-" + Y + " is a " + Terrain;
        }

        public int getX()
        {
            return this.X;
        }

        public int getY()
        {
            return this.Y;
        }

        public int getMoveRed()
        {
            return this.Terrain.getMoveRed();
        }

        public void setUnit(Unit u)
        {
            this.Unit = u;
        }

        public Unit getUnit()
        {
            return this.Unit;
        }

        public Terrain getTerrain()
        {
            return this.Terrain;
        }

        public int getTerrainDef()
        {
            return this.Terrain.getBonusDef();
        }
    }
}

