﻿using UnityEngine;
using System.Collections;
using System;
using UnityEngine.UI;

namespace AssemblyCSharp
{
    public class UIController : MonoBehaviour
    {
        public Text textElement;
        public GameManager gameManager;
        public String option;

        private Tile tileCursor;
        private Tile tileSelected;

        // LateUpdate is called after Update each frame
        void LateUpdate()
        {
            if (option == "selectedUnit")
            {
                if (gameManager.boardScript.unitSelected != null)
                {
                    tileSelected = gameManager.boardScript.Map[gameManager.boardScript.unitSelected.getPosition().getX(), gameManager.boardScript.unitSelected.getPosition().getY()].tile;
                    setSelectedUnitInfo();
                }
                else
                {
                    this.textElement.text = "";
                }
            }
            else if (option == "selectedTerrain")
            {
                if (gameManager.boardScript.unitSelected != null)
                {
                    tileSelected = gameManager.boardScript.Map[gameManager.boardScript.unitSelected.getPosition().getX(), gameManager.boardScript.unitSelected.getPosition().getY()].tile;
                    setSelectedTerrainInfo();
                }
                else
                {
                    this.textElement.text = "";
                }
            }
            else if (option == "cursorUnit")
            {
                tileCursor = gameManager.boardScript.Map[(int)gameManager.boardScript.cursor.transform.position.x, (int)gameManager.boardScript.cursor.transform.position.y].tile;
                if (tileCursor.getUnit() != null)
                {
                    setCursorUnitInfo();
                }
                else
                {
                    this.textElement.text = "";
                }
            }
            else if (option == "cursorTerrain")
            {
                tileCursor = gameManager.boardScript.Map[(int)gameManager.boardScript.cursor.transform.position.x, (int)gameManager.boardScript.cursor.transform.position.y].tile;
                setCursorTerrainInfo();
            }
            else
            {
                Debug.Log("Wrong option");
            }




            /*
            tileCursor = gameManager.boardScript.Map[(int)gameManager.boardScript.cursor.transform.position.x, (int)gameManager.boardScript.cursor.transform.position.y].tile;
            setCursorTerrainInfo();
            if (tileCursor.getUnit() != null)
            {
                setCursorUnitInfo();
            }
            else
            {
                this.textElement.text = "";
            }

            if (gameManager.boardScript.unitSelected != null)
            {
                tileSelected = gameManager.boardScript.Map[gameManager.boardScript.unitSelected.getPosition().getX(), gameManager.boardScript.unitSelected.getPosition().getY()].tile;
                setSelectedUnitInfo();
                setSelectedTerrainInfo();
            }
            else
            {
                this.textElement.text = "";
            }*/
        }

        void setCursorUnitInfo()
        {
            this.textElement.text = tileCursor.getUnit().getClass() + "\n" + tileCursor.getUnit().getCurrentHP() + " HP\n" + tileCursor.getUnit().getAtk() + " ATK\n" + tileCursor.getUnit().getDef() + " DEF\n" + tileCursor.getUnit().getMovement() + " MOV\n" + tileCursor.getUnit().getRange() + " MOV\n";
        }

        void setCursorTerrainInfo()
        {
            this.textElement.text = tileCursor.getTerrain().Type + "\n" + tileCursor.getTerrainDef() + " DEF\n" + "-" + tileCursor.getMoveRed() + " MOV\n";
        }

        void setSelectedUnitInfo()
        {
            this.textElement.text = tileSelected.getUnit().getClass() + "\n" + tileSelected.getUnit().getCurrentHP() + " HP\n" + tileSelected.getUnit().getAtk() + " ATK\n" + tileSelected.getUnit().getDef() + " DEF\n" + tileSelected.getUnit().getMovement() + " MOV\n" + tileSelected.getUnit().getRange() + " MOV\n";
        }

        void setSelectedTerrainInfo()
        {
            this.textElement.text = tileSelected.getTerrain().Type + "\n" + tileSelected.getTerrainDef() + " DEF\n" + "-" + tileSelected.getMoveRed() + " MOV\n";

        }
    }
}