﻿using System;
using System.Collections.Generic;

/*  Aquesta classe té 4 atributs: el code, que és únic i tracta un element de la matriu
 *  (X_Y), una llista de relacions nearBy (es una tuple que conte un vertex i un cost per
 *  accedir-hi), que pot anar de 2 a 4 elements . Aquests dosatributs són estàtics quan es
 *  la matriu i ja no es modifiquen més. Els altres dos, minDist i previous, varien i s'utilitzen
 *  per fer càlculs de moviemnt.
 */


namespace AssemblyCSharp
{

    public class Vertex
    {
        private int X;
        private int Y;
        private List<Relation> nearBy { get; set; } // 2~4 elements
        private int minDist { get; set; }
        private Vertex previous { get; set; }

        public Vertex() { }

        public Vertex(int x, int y)
        {
            this.X = x;
            this.Y = y;
            this.nearBy = new List<Relation>();
            this.minDist = int.MaxValue; // Initialized at max value
        }

        public void addRelation(Relation r)
        {
            nearBy.Add(r);
        }


        public void setMinDist(int d)
        {
            this.minDist = d;
        }

        public int getMinDist()
        {
            return this.minDist;
        }

        public List<Relation> getNearBy()
        {
            return this.nearBy;
        }

        public void setPrevious( Vertex v)
        {
            this.previous = v;
        }

        public Vertex getPrevious()
        {
            return this.previous;
        }

        public int getX()
        {
            return this.X;
        }

        public int getY()
        {
            return this.Y;
        }

        public String toString() { return this.X + "_" + this.Y; }

        // Compare minimal distances between two vertexs
        public int compareTo(Vertex v) { return this.minDist.CompareTo(v.minDist); }


    }
}